/* vxsplit.c/vxjoin.c
**
** Hauptprogramm zu `vxsplit/vxjoin'.
**
** Aufgabe dieses Programmes ist es, einen vorhandenen VxMail-Folder in
** seine einzelnen E-Mails zu zerlegen bzw mehrere E-Mails zu einem
** VxMail-Folder zusammenzufassen. Die E-Mails werden hierbei in
** Dateien `XXXXXX' abgelegt, wobei jedes `X' fr eine Ziffer steht.
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#include "config.h"
#include "prefs.h"
#include "conf.h"
#include "tools.h"
#include "vxerror.h"
#include "xfile.h"
#include "conv.h"
#include "version.h"
#include "vxopt.h"

void usage (void)
{
    fprintf (stderr, "\nUsage: %s [-f <configfile>] <folderfile> ..."
		     "\n       %s -h"
		     "\n       %s -V\n"
		     "\n   -f <configfile>"
		     "\n       read configuration from file <configfile>"
		     "\n       (default: %s)"
		     "\n   -h"
		     "\n       show this help"
		     "\n   -V"
		     "\n       show the program's version number\n\n",
		     progname, progname, progname, CONFIGFILE);
    exit (1);
}

int main (int argc, char *argv[])
{
    int ix, fc;

    vxopt (&argc, argv, usage);
    if ((progname = strrchr(argv[0], '/'))) ++progname; else progname = argv[0];

    if (argc < 2) {
	fprintf (stderr, "%s: no folder file specified!\n", progname);
	exit (1);
    }
    if (strcmp (progname, "vxsplit") && strcmp (progname, "vxjoin")) {
	fprintf (stderr, "%s: unknown operation! Please use `vxsplit' or "
			 "`vxjoin' instead!\n", progname);
    /* Lies die Konfigurationsdatei ein. */
    getconf ();
    /* Initialisiere den Konverter. */
    if (!strcmp (progname, "vxsplit")) {
	fc = 0;
	for (ix = 1; ix < argc; ++ix) {
	    char line[1024], fn[128];
	    int jx;
	    FILE *fp;
	    xFile fx = xOpen (argv[ix], "rx");
	    if (!fx) {
		fprintf (stderr, "%s: opening folder `%s' failed",
				 progname, argv[ix]);
		perror ("");
		continue;
	    }
	    for (jx = 0; xSeek (fx, (off_t) jx) >= 0; ++jx) {
		sprintf (fn, "%06d", fc++);
		if ((fp = fopen (fn, "w")) == NULL) {
		    vxerror_at (EX_OSERR, errno, __FILE__, __LINE__,
				"creating file `%s' failed",fn);
		}
		while (xGets (line 1024, fx) > 0) { fputs (line, fp); }
		fclose (fp);
	    }
	    xClose (fx);
	}
    } else {
	xx
    /* Konvertiere jede angegebene Folderdatei. */
    for (ix = 1; ix < argc; ++ix) {
	xFile fx = xOpen (argv[ix], "ix", prefs.fperm);
	if (!fx) {
	    fprintf (stderr, "%s: opening folder `%s' failed",
			     progname,
			     argv[ix]);
	    perror ("");
	    continue;
	}
	conv (fx);
	xClose (fx);
    }
    return 0;
}
