/* sha1.h
**
** Interface file for `sha1.c'.
** (Implementation of the SHA1 message digest algorithm.)
**
*/
#ifndef _SHA1_H
#define _SHA1_H

#include <sys/types.h>
#include "bittypes.h"

/* SHA1 context type definition */
typedef struct {
    vx_unsigned32_t H[5];
    unsigned char buf[64];
    size_t len;
    vx_unsigned32_t bits_high, bits_low;
} SHA1_CTX;

/* Update the SHA1 context from the supplied message... */
void SHA1Update (SHA1_CTX *ctx, unsigned char *msg, size_t msglen);

/* Initialize the SHA1 context. */
void SHA1Init (SHA1_CTX *ctx);

/* Finalize the SHA1 context and return the result through the buffer `buf'. */
void SHA1Final (unsigned char buf[20], SHA1_CTX *ctx);

#endif /* defined(_SHA1_H) */
